go语言中的defer、panic、recover处理异常

DEC_LIU · · 9604 次点击 · · 开始浏览    
这是一个创建于 的文章,其中的信息可能已经有所发展或是发生改变。

go语言中的defer就像c++中的析构函数,但是go语言中defer的对象是函数(或者对象的方法),defer能保证在函数结束最后执行该方法(函数),但是有例外:如果在定义的方法中defer定义的方法如果在panic后面,defer定义的方法就无法执行到。

panic 是用来表示非常严重的不可恢复的错误的。在Go语言中这是一个内置函数,接收一个interface{}类型的值作为参数。panic 的作用就像我们平常接触的异常。不过Go可没有try…catch,所以,panic一般会导致程序挂掉(除非recover)。所以,Go语言中的异 常,那真的是异常了。你可以试试,调用panic看看,程序立马挂掉,然后Go运行时会打印出调用栈。
但是,关键的一点是,即使函数执行的时候 panic了,函数不往下走了,运行时并不是立刻向上传递panic,而是到defer那,等defer的东西都跑完了,panic再向上传递。所以这时 候 defer 有点类似 try-catch-finally 中的 finally。
panic就是这么简单。抛出个真正意义上的异常。

panic的函数并不会立刻返回,而是先defer,再返回,如果有办法将panic捕获到,并阻止panic传递,就正常处理,如果没有没有捕获,程序直接异常终止(可以注释掉下面程序中的recover试一试)。

Go语言提供了recover内置函数,前面提到,一旦panic,逻辑就会走到defer那,那我们就在defer那等着,调用recover函 数将会捕获到当前的panic(如果有的话),被捕获到的panic就不会向上传递了,于是,世界恢复了和平。你可以干你想干的事情了。

不过要注意的是,recover之后,逻辑并不会恢复到panic那个点去,函数还是会在defer之后返回。

请看下面的例子:

// go_exception project main.go

package main
import (
    "fmt"
)
func f() {
    defer func() {
        fmt.Println("inner func defer")
    }()
    fmt.Println("A")
    panic(3)
//panic方法后的方法、defer定义的方法都无法执行,也包括函数f()后面的任何方法以及defer定义的方法 
    defer func() {
        fmt.Println("inner func defer 1")
    }()
    //以下2个不能执行
    fmt.Println("b")
    fmt.Println("c")
}
func main() {
    fmt.Println("Hello World!")
    defer func() {
        fmt.Println("FUCK——1")
    }()
    defer func() {
        fmt.Println("d")
        if err := recover(); err != nil {
            fmt.Println(err)
        }
        fmt.Println("e")
    }()
    defer func() {
        fmt.Println("FUCK——2")
    }()
    f()
    //在f()函数以后的defer函数也不能执行
    defer func() {
        fmt.Println("FUCK——3")
    }()
}
运行输出结果:

E:/go_project/src/go_exception/go_exception.exe [E:/go_project/src/go_exception]

Hello World!

A

inner func defer

FUCK——2

d

3

e

FUCK——1

成功: 进程退出代码 0.

结果输出结果大家可以更好的理解defer、panic、revover处理机制了。

将上面的例子改成:

// go_exception project main.go

package main
import (
    "fmt"
)
func f() {
    defer func() {
        fmt.Println("inner func defer")
        if err := recover(); err != nil {
            fmt.Println(err, " fuck")
        }
    }()
    fmt.Println("A")
    panic(3)
    defer func() {
        fmt.Println("inner func defer 1")
    }()
    //以下2个不能执行
    fmt.Println("b")
    fmt.Println("c")
}
func main() {
    fmt.Println("Hello World!")
    defer func() {
        fmt.Println("FUCK——1")
    }()
    defer func() {
        fmt.Println("d")
        if err := recover(); err != nil {
            fmt.Println(err)
        }
        fmt.Println("e")
    }()
    defer func() {
        fmt.Println("FUCK——2")
    }()
    f()
    //在f()函数以后的defer函数也不能执行
    defer func() {
        fmt.Println("FUCK——3")
    }()
}
输出:

E:/go_project/src/go_exception/go_exception.exe [E:/go_project/src/go_exception]

Hello World!

A

inner func defer

3 fuck

FUCK——3

FUCK——2

d

e

FUCK——1

成功: 进程退出代码 0.

从以上结果可以看出,如果panic被recover捕获接收到,panic后的方法还是能继续执行的。

在看到许式伟的defer、panic、recover处理错误异常的时候,文章中有以下文字描述:

“当在一个函数执行过程中调用panic()函数时,正常的函数执行流程将立即终止,但函数中
之前使用defer 关键字延迟执行的语句将正常展开执行,之后该函数将返回到调用函数,并导致
逐层向上执行panic流程,直至所属的goroutine 中所有正在执行的函数被终止。错误信息将被报
告,包括在调用panic()函数时传入的参数,这个过程称为错误处理流程。”

执行完例子后对这句话理解的更深刻了。

总结:不建议使用panic、recover,除非必须要用。


有疑问加站长微信联系(非本文作者)

本文来自:开源中国博客

感谢作者:DEC_LIU

查看原文:go语言中的defer、panic、recover处理异常

入群交流(和以上内容无关):加入Go大咖交流群,或添加微信:liuxiaoyan-s 备注:入群;或加QQ群:701969077

9604 次点击  
加入收藏 微博
2 回复  |  直到 2000-01-01 00:00:00
暂无回复
添加一条新回复 (您需要 登录 后才能回复 没有账号 ?)
  • 请尽量让自己的回复能够对别人有帮助
  • 支持 Markdown 格式, **粗体**、~~删除线~~、`单行代码`
  • 支持 @ 本站用户;支持表情(输入 : 提示),见 Emoji cheat sheet
  • 图片支持拖拽、截图粘贴等方式上传